# Do not modify this file!  It was generated by ‘nixos-generate-config’
# and may be overwritten by future invocations.  Please make changes
# to /etc/nixos/configuration.nix instead.
{ config, lib, pkgs, inputs, modulesPath, ... }:

{
  imports = [
    (modulesPath + "/installer/scan/not-detected.nix")
#    inputs.nixos-hardware.nixosModules.microsoft-surface
  ];

  # Kernel Modules
  boot = {
    initrd.availableKernelModules = [ "xhci_pci" "nvme" "usbhid" "usb_storage" "sd_mod" ];
    initrd.kernelModules = [ ];
    kernelPackages = pkgs.linuxPackages_zen;
    extraModulePackages = with config.boot.kernelPackages; [ v4l2loopback ];
    kernelModules = [ "kvm-intel" "v4l2loopback" ];
    loader = {
      systemd-boot = {
        enable = true;
        configurationLimit = 10;
      };
      efi.canTouchEfiVariables = true;
    };
  };

  # Modules
  modules.hardware = {
    audio = {
      enable = true;
      enableExtraCompat = true;
    };
    graphics.enable = true;
    fs = {
      enable = true;
      ssd.enable = true;
    };
  };

  # HiDPI
  hardware.video.hidpi.enable = true;

  # CPU
  nix.maxJobs = lib.mkDefault 4;
  hardware.cpu.intel.updateMicrocode = true;

  # Power Management
  powerManagement = {
    powertop.enable = true;
    cpuFreqGovernor = lib.mkDefault "powersave";
  };

  environment.systemPackages = with pkgs; [
    brightnessctl
  ];

  # Filesystems
  fileSystems = {
    "/" = {
      device = "/dev/disk/by-uuid/b892a566-b6d7-4f62-a384-71ccca4ff4d8";
      fsType = "f2fs";
      options = [ "defaults" "noatime" "nodiratime" ];
    };

    "/home" = {
      device = "/dev/disk/by-uuid/f3a44427-a212-48c2-91e7-f40e82bbcc02";
      fsType = "f2fs";
      options = [ "defaults" "noatime" "nodiratime" ];
    };

    "/etc/dotfiles" = {
      device = "/dev/disk/by-uuid/2777d90a-20f0-4b35-88f1-653ba14114db";
      fsType = "f2fs";
      options = [ "defaults" "noatime" "nodiratime" ];
    };

    "/boot" = {
      device = "/dev/disk/by-uuid/C507-604E";
      fsType = "vfat";
    };

    "/home/aether/Downloads" = {
      device = "none";
      fsType = "tmpfs";
    };

    "/run/media/aether/bf2d91f1-a6b3-4629-8755-76301b3f6f56" = {
      device = "/dev/disk/by-uuid/bf2d91f1-a6b3-4629-8755-76301b3f6f56";
#      fsType = "f2fs";
      options = [ "defaults" "noatime" "nodiratime" "user" "nofail" ];
    };

    "/home/aether/Videos" = {
      device = "/run/media/aether/bf2d91f1-a6b3-4629-8755-76301b3f6f56/home delta/Videos";
      options = [ "bind" ];
    };

    "/home/aether/Pictures" = {
      device = "/run/media/aether/bf2d91f1-a6b3-4629-8755-76301b3f6f56/home delta/Pictures";
      options = [ "bind" ];
    };

    "/home/aether/Documents" = {
      device = "/run/media/aether/bf2d91f1-a6b3-4629-8755-76301b3f6f56/home delta/Documents";
      options = [ "bind" ];
    };

    "/home/aether/Music" = {
      device = "/run/media/aether/bf2d91f1-a6b3-4629-8755-76301b3f6f56/home delta/home delta delta/Music";
      options = [ "bind" ];
    };

    "/home/aether/Textures" = {
      device = "/run/media/aether/bf2d91f1-a6b3-4629-8755-76301b3f6f56/home\ delta/Textures";
      options = [ "bind" ];
    };

    "/home/aether/Porn" = {
      device = "/run/media/aether/bf2d91f1-a6b3-4629-8755-76301b3f6f56/home\ delta/Porn";
      options = [ "bind" ];
    };
  };

  swapDevices = [{ device = "/dev/disk/by-uuid/e4a7edca-2c4e-4979-8368-377bc067b8bd"; }];

  # Allows for hibernation
  boot.resumeDevice = "/dev/disk/by-uuid/e4a7edca-2c4e-4979-8368-377bc067b8bd";
}
